/*  Copyright (c) 2009 Delft University of Technology

    This file is part of the mac-framework package.

    The mac-framework pakcage is free software: you can redistribute it
    and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    The mac-framework pakcage is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with the mac-framework package.  If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef TIMESYNC_H
#define TIMESYNC_H

/**
 * 40 bit global time.
 */
typedef nx_struct {
	nx_uint8_t high;
	nx_uint32_t low;
} globaltime_t;

/**
 * Header for timestamped messages.
 */
typedef nx_struct {
	globaltime_t timestamp;
} timesync_header_t;

/**
 * State of time synchronization.
 */
typedef enum {
	NOT_SANE = 1,	// not synchronized at all
	TX_SANE,			// we appear to be alone, transmitting a message will make us sane
	SANE				// synchronized
} sanitystate_t;

typedef struct {
	uint32_t adjustments;	// number of times since boot global time was adjusted
} timesync_status_t;

#endif
