/*  Copyright (c) 2009 Delft University of Technology

    This file is part of the mac-framework package.

    The mac-framework pakcage is free software: you can redistribute it
    and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    The mac-framework pakcage is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with the mac-framework package.  If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef ASSERTUART_H
#define ASSERTUART_H

// Preprocessor magic to get __LINE__ as a string, from
// http://www.decompile.com/cpp/faq/file_and_line_error_string.htm
#define STRINGIFY(x) #x
#define TOSTRING(x) STRINGIFY(x)

// The AVR has oodles of ROM, so I'm setting the default to include file names -- Michiel
#ifndef ASSERT_UART_EXCLUDE_FILE_NAME
#define ASSERT_UART_INCLUDE_FILE_NAME
#endif

// Long paths in __FILE__ file names may use excessive amounts
// of memory (either ROM or both ROM and RAM, depending on your compiler)
// so this define allows you to switch file names on and off.
#ifdef ASSERT_UART_INCLUDE_FILE_NAME
#define SOURCE_LOCATION __FILE__ ":" TOSTRING(__LINE__)
#else
#define SOURCE_LOCATION TOSTRING(__LINE__)
#endif

// put the strings in ROM by using PSTR
#define assert(condition, output) doAssert((condition), (output), PSTR(#output), PSTR(SOURCE_LOCATION))
#define assertNot(condition, output) doAssertNot((condition), (output), PSTR(#output), PSTR(SOURCE_LOCATION))
#define assertSuccess(error, output) doAssertSuccess((error), (output), PSTR(#output), PSTR(SOURCE_LOCATION))

#endif
