/*  Copyright (c) 2009 Delft University of Technology

    This file is part of the mac-framework package.

    The mac-framework pakcage is free software: you can redistribute it
    and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    The mac-framework pakcage is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with the mac-framework package.  If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef PHYCOMM_H
#define PHYCOMM_H

// data rate in bits per second
#define BAUD_RATE 19200UL

// at 19200 bps, 5 preamble plus 2 sync bytes take very nearly 3 ms (2.986...)
// which is nice for time synchronization given its millisecond resolution
#define DEFAULT_PREAMBLE_LENGTH 5

#ifdef FIXED_BATTERY // battery changes mess with ADC values
// RSSI values under 300 indicate a carrier
#define CARRIER_SENSE_RSSI_THRESHOLD 300
#else
#define CARRIER_SENSE_RSSI_THRESHOLD 256
#endif

#if defined PLATFORM_MICA2 && defined AVRORA_BUILD
#define PROC_DELAY 4
#else
// experimentally determined packet delay (in ms) due to processing, mode switching, etc.
#define PROC_DELAY 3
#endif

// Time for the radio to switch from sleep mode to receive mode
#define RADIO_WAKEUP_TIME 2
#endif
