/*  Copyright (c) 2009 Delft University of Technology

    This file is part of the mac-framework package.

    The mac-framework pakcage is free software: you can redistribute it
    and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    The mac-framework pakcage is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with the mac-framework package.  If not, see
    <http://www.gnu.org/licenses/>.
*/

#ifndef LAMBDA_H
#define LAMBDA_H

#define UQ_LAMBDA "LambdaC"
#define UQ_MULTIPLEX "LambdaP"

/**
 * Header for lambda messages.
 */
typedef nx_struct {
	nx_uint8_t lambdaType;
} lambda_header_t;

/**
 * Status/statistics for LambdaBcast.
 */
typedef struct {
	uint32_t received;
	uint32_t sent;
} lambda_bcast_status_t;

/**
 * Status/statistics for LambdaUnicast.
 */
typedef struct {
	uint32_t dataReceived;
	uint32_t dataOverheard;
	uint32_t dataSent;
	uint32_t ackReceived;
	uint32_t ackOverheard;
	uint32_t ackSent;
} lambda_unicast_status_t;

#endif
