/*  Copyright (c) 2009 Delft University of Technology

    This file is part of the mac-framework package.

    The mac-framework pakcage is free software: you can redistribute it
    and/or modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    The mac-framework pakcage is distributed in the hope that it will be
    useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with the mac-framework package.  If not, see
    <http://www.gnu.org/licenses/>.
*/

#define LAMBDA_INTERFACES \
	provides { \
		interface Init @atleastonce(); \
		interface StdControl; \
		interface Send; \
		interface Receive; \
		interface Receive as Snoop; \
		interface AllocateTime; \
		interface Packet; \
	} \
	uses { \
		interface StdControl as SubControl; \
		interface Send as SubSend; \
		interface Receive as SubReceive; \
		interface Receive as SubSnoop; \
		interface PhyComm; \
		interface Packet as SubPacket; \
		interface AMPacket; \
	}

#define LAMBDA_PACKET_IMPLEMENT(_x) \
	command void Packet.clear(message_t* msg) { \
		call SubPacket.clear(msg); \
	} \
 \
	command uint8_t Packet.payloadLength(message_t* msg) { \
		return call SubPacket.payloadLength(msg) - (_x); \
	} \
 \
	command void Packet.setPayloadLength(message_t* msg, uint8_t len) { \
		call SubPacket.setPayloadLength(msg, len + (_x)); \
	} \
 \
	command uint8_t Packet.maxPayloadLength() { \
		return call SubPacket.maxPayloadLength() - (_x); \
	} \
 \
	command void* Packet.getPayload(message_t* msg, uint8_t len) { \
		uint8_t* payload = (uint8_t*) call SubPacket.getPayload(msg, len + (_x)); \
		return payload != NULL ? payload + (_x) : NULL; \
	}


#define LAMBDA_SEND_RECEIVE_PACKET \
	command uint8_t Send.maxPayloadLength() { \
		return call Packet.maxPayloadLength(); \
	} \
 \
	command void* Send.getPayload(message_t* msg, uint8_t len) { \
		return call Packet.getPayload(msg, len); \
	}

